#todo: to be remplaced by python file
#todo: add also the launching of Hecuba storage, is it possible based on this hint
#https://compss-doc.readthedocs.io/en/stable/Sections/06_Persistent_Storage/05_Own_interface.html?highlight=enqueue_compss#using-enqueue-compss

module load COMPSs
module use /apps/HECUBA/modulefiles
module load Hecuba/1.0_api
# not needed since Hecuba loads its own version of python (3.6.4_ML)
#module load python
# experiment configuration
# only parameter - #CORES
export FESOM_CORES=$1
export QOS=$2
export MEMBERS=$3
# for the moment hardcoded until COMPS is patched
export FESOM_WORKINGDIR="/home/bsc32/bsc32044/pycompss_workflow_tests/1948"
export FESOM_EXE="fesom.x"
export NODE_ALLOCATION=$(((${FESOM_CORES}/48)*${MEMBERS}))
echo "Number of cores: ${FESOM_CORES}"
echo "Number of nodes to be used: ${NODE_ALLOCATION}"

#added by support to prevent the segmentation fault
ulimit -Ss unlimited

# Sample invocation of this script:
# ./launch_mn4.sh 288 debug 1
# ./launch_mn4.sh 144 bsc 3
# $1 number of cores needed by the task
# $2 QoS to be used (determines the queue)
# $3 number of simulations of the ensemble

EXP_ID=$(printf "%06d\n" $((1 + $RANDOM % 100000)))

# launch hecuba_lib & dynamic analysis process (pruning)
#enqueue_compss -t  --sc_cfg=mn.cfg \
#                   --log_level=debug \
#                   --qos=${QOS} \
#                   --storage_props=$PWD/hecuba_lib/storage_props.cfg \
#                   --storage_home=$HECUBA_ROOT/compss \
#                   --job_name=pruning \
#                   --exec_time=20 \
#                   --worker_in_master_cpus=48 \
#                   --num_nodes=2  \
#                   --pythonpath=$PWD:$HECUBA_ROOT/compss  esm_pruning.py ${EXP_ID}


# launch the simulation non hecuba_lib (WORKING)
#enqueue_compss -t  --sc_cfg=mn.cfg --qos=${QOS} --log_level=debug  --job_name=fesom2 --exec_time=20 --worker_in_master_cpus=48 --num_nodes=${NODE_ALLOCATION}  --pythonpath=$PWD  esm_simulation.py ${EXP_ID}

# launch the simulation with hecuba_lib (WORKING)
enqueue_compss -t  --sc_cfg=mn.cfg  \
               --qos=${QOS}  \
               --storage_props=$PWD/hecuba_lib/storage_props.cfg \
               --storage_home=$HECUBA_ROOT/compss \
               --log_level=debug \
               --job_name=esm_workflow  \
               --exec_time=20  \
               --worker_in_master_cpus=48  \
               --num_nodes=${NODE_ALLOCATION}  \
               --pythonpath=$PWD:$HECUBA_ROOT/compss  esm_simulation.py ${EXP_ID}
